<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="奖励类型 0 推广奖励 1 投票奖励:" prop="type">
          <el-select v-model="formData.type" placeholder="请选择" :clearable="true">
            <el-option v-for="(item,key) in twi_reward_typeOptions" :key="key" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="对应users表编号:" prop="userId">
          <el-input v-model.number="formData.userId" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="reward字段:" prop="reward">
          <el-input-number v-model="formData.reward" :precision="2" :clearable="true"></el-input-number>
        </el-form-item>
        <el-form-item label="invitorId字段:" prop="invitorId">
          <el-input v-model.number="formData.invitorId" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="0 未发送 1 已发送 2 发送失败 3 发送成功:" prop="status">
          <el-select v-model="formData.status" placeholder="请选择" :clearable="true">
            <el-option v-for="(item,key) in twi_reward_statusOptions" :key="key" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'PoolRewardList'
}
</script>

<script setup>
import {
  createPoolRewardList,
  updatePoolRewardList,
  findPoolRewardList
} from '@/api/poolRewardList'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const twi_reward_typeOptions = ref([])
const twi_reward_statusOptions = ref([])
const formData = ref({
            type: undefined,
            userId: 0,
            reward: 0,
            invitorId: 0,
            status: undefined,
        })
// 验证规则
const rule = reactive({
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findPoolRewardList({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.repoolRewardList
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
    twi_reward_typeOptions.value = await getDictFunc('twi_reward_type')
    twi_reward_statusOptions.value = await getDictFunc('twi_reward_status')
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createPoolRewardList(formData.value)
               break
             case 'update':
               res = await updatePoolRewardList(formData.value)
               break
             default:
               res = await createPoolRewardList(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
